<template>
  <div class="app-container">
    <!--满减方案-->
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item>
        <el-button icon="el-icon-refresh" size="mini" @click="handleAdd" v-hasPermi="['market:setting:add']" >添加等级</el-button>
      </el-form-item>
    </el-form>
    <el-table v-loading="loading" :data="planList" >
      <el-table-column label="id" align="center" prop="id" />
      <el-table-column label="等级名称" align="center" prop="grade" />
      <el-table-column label="优惠条件" align="center" prop="discountTerm" />
      <el-table-column label="优惠条件金额" v-show="false" align="center" prop="discountAmt" />
      <el-table-column label="汽油优惠金额" align="center" prop="gasoilDiscountAmt" />
      <el-table-column label="柴油优惠金额" align="center" prop="dieseloilDiscountAmt" />
      <el-table-column label="会员优惠是否叠加" align="center" prop="vipDiscountyPlus" />
      <el-table-column label="可否叠加劵" align="center" prop="couponPlus" />
      <el-table-column label="优惠方案类型" v-show="false" align="center" prop="discountPlanType" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['market:plan:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['market:plan:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 添加或修改客户优惠等级设置对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="90px">
        <el-form-item label="等级名称" prop="grade">
          <el-input v-model="form.grade" placeholder="请输入等级名称" />
        </el-form-item>
        <el-form-item label="优惠条件" prop="discountTerm">
          <el-input v-model="form.discountTerm" placeholder="请输入优惠条件" />
        </el-form-item>
        <el-form-item label="优惠条件金额" prop="discountAmt">
          <el-input v-model="form.discountAmt" placeholder="请输入优惠条件金额" />
        </el-form-item>
        <el-form-item label="汽油优惠金额" prop="gasoilDiscountAmt">
          <el-input v-model="form.gasoilDiscountAmt" placeholder="请输入汽油优惠金额" />
        </el-form-item>
        <el-form-item label="柴油优惠金额" prop="dieseloilDiscountAmt">
          <el-input v-model="form.dieseloilDiscountAmt" placeholder="请输入柴油优惠金额" />
        </el-form-item>
        <el-form-item label="会员优惠是否叠加" prop="vipDiscountyPlus">
          <el-input v-model="form.vipDiscountyPlus" placeholder="请输入会员优惠是否叠加" />
        </el-form-item>
        <el-form-item label="可否叠加劵" prop="couponPlus">
          <el-input v-model="form.couponPlus" placeholder="请输入可否叠加劵" />
        </el-form-item>
        <el-form-item label="优惠方案类型" prop="discountPlanType">
          <el-select v-model="form.discountPlanType" placeholder="请选择优惠方案类型">
            <el-option label="请选择字典生成" value="" />
          </el-select>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
    <!--立减方案-->
    <el-form :model="selectParams" ref="selectFrom" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item>
        <el-button icon="el-icon-refresh" size="mini" @click="handleAddDT" v-hasPermi="['market:setting:add']" >添加动态等级</el-button>
      </el-form-item>
    </el-form>
    <el-table v-loading="loading" :data="DTplanList" >
      <el-table-column label="id" align="center" prop="id" v-if="false" />
      <el-table-column label="等级名称" align="center" prop="grade" />
      <el-table-column label="优惠条件" align="center" prop="discountTerm" />
      <el-table-column label="优惠条件金额" v-show="false" align="center" prop="discountAmt" />
      <el-table-column label="汽油优惠金额" align="center" prop="gasoilDiscountAmt" />
      <el-table-column label="柴油优惠金额" align="center" prop="dieseloilDiscountAmt" />
      <el-table-column label="会员优惠是否叠加" align="center" prop="vipDiscountyPlus" />
      <el-table-column label="可否叠加劵" align="center" prop="couponPlus" />
      <el-table-column label="优惠方案类型" v-show="false" align="center" prop="discountPlanType" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope1">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdateDT(scope1.row)"
            v-hasPermi="['market:setting:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDeleteDT(scope1.row)"
            v-hasPermi="['market:setting:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 添加或修改动态客户优惠等级设置对话框 -->
    <el-dialog :title="title" :visible.sync="opendt" width="500px" append-to-body>
      <el-form ref="dtform" :model="dtform" :rules="dtrules" label-width="110px">
        <el-form-item label="等级名称" prop="grade">
          <el-input v-model="dtform.grade" placeholder="请输入等级名称" />
        </el-form-item>
        <el-form-item label="优惠条件" prop="discountTerm">
          <el-input v-model="dtform.discountTerm" placeholder="请输入优惠条件" />
        </el-form-item>
        <el-form-item label="优惠条件金额" prop="discountAmt">
          <el-input v-model="dtform.discountAmt" placeholder="请输入优惠条件金额" />
        </el-form-item>
        <el-form-item label="汽油优惠金额" prop="gasoilDiscountAmt">
          <el-input v-model="dtform.gasoilDiscountAmt" placeholder="请输入汽油优惠金额" />
        </el-form-item>
        <el-form-item label="柴油优惠金额" prop="dieseloilDiscountAmt">
          <el-input v-model="dtform.dieseloilDiscountAmt" placeholder="请输入柴油优惠金额" />
        </el-form-item>
        <el-form-item label="会员优惠是否叠加" prop="vipDiscountyPlus">
          <el-input v-model="dtform.vipDiscountyPlus" placeholder="请输入会员优惠是否叠加" />
        </el-form-item>
        <el-form-item label="可否叠加劵" prop="couponPlus">
          <el-input v-model="dtform.couponPlus" placeholder="请输入可否叠加劵" />
        </el-form-item>
        <el-form-item label="优惠方案类型" prop="discountPlanType">
          <el-select v-model="dtform.discountPlanType" placeholder="请选择优惠方案类型">
            <el-option label="请选择字典生成" value="" />
          </el-select>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitFormDT">确 定</el-button>
        <el-button @click="cancelDT">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
  import { listPlan, getPlan, delPlan, addPlan, updatePlan, exportPlan } from "@/api/market/plan";

  export default {
    name: "Setting",
    data() {
      return {
        // 遮罩层
        loading: true,
        // 选中数组
        ids: [],
        // 非单个禁用
        single: true,
        // 非多个禁用
        multiple: true,
        // 显示搜索条件
        showSearch: true,
        // 总条数
        total: 0,
        // 客户优惠等级设置表格数据
        planList: [],
        DTplanList: [],
        // 弹出层标题
        title: "",
        // 是否显示弹出层
        open: false,
        opendt: false,
        // 查询参数
        queryParams: {
          pageNum: 1,
          pageSize: 10,
          grade: null,
          discountWay: null,
          gasoilDiscountLitre: null,
          dieseloilDiscountLitre: null,
          gradeType: null,
          gasoilConsume: null,
          gasoilGrowthValue: null,
          dieseloilConsume: null,
          dieseloilGrowthValue: null,
          growthValue: null,
          date: null,
          deductionGrowthValue: null
        },// 查询参数

        selectParams: {
          pageNum: 1,
          pageSize: 10,
          grade: null,
          discountWay: null,
          gasoilDiscountLitre: null,
          dieseloilDiscountLitre: null,
          gradeType: null,
          gasoilConsume: null,
          gasoilGrowthValue: null,
          dieseloilConsume: null,
          dieseloilGrowthValue: null,
          growthValue: null,
          date: null,
          deductionGrowthValue: null
        },
        // 表单参数
        form: {},
        dtform: {},
        ruleForm: {},
        // 表单校验
        rules: {
        },
        dtrules: {
        }
      };
    },
    created() {
      this.getList();
      this.getList2();
    },
    methods: {
      /** 查询客户优惠等级设置列表 */
      getList() {
        this.queryParams.gradeType="1";
        this.loading = true;
        listPlan(this.queryParams).then(response => {
          this.planList = response.rows;
          this.total = response.total;
          this.loading = false;
        });
      },
      getList2() {
        this.selectParams.gradeType="3";
        this.loading = true;
        listPlan(this.selectParams).then(response => {
          this.DTplanList = response.rows;
          this.total = response.total;
          this.loading = false;

        });
      },

      // 取消按钮
      cancel() {
        this.open = false;
        this.reset();
      },
      // 取消按钮
      cancelDT() {
        this.opendt = false;
        this.reset();
      },
      // 表单重置
      reset() {
        this.form = {
          id: null,
          grade: null,
          discountWay: null,
          gasoilDiscountLitre: null,
          dieseloilDiscountLitre: null,
          gradeType: null,
          gasoilConsume: null,
          gasoilGrowthValue: null,
          dieseloilConsume: null,
          dieseloilGrowthValue: null,
          growthValue: null,
          date: null,
          deductionGrowthValue: null
        };
        this.resetForm("form");
      },

      /** 新增按钮操作 */
      handleAdd() {
        this.reset();
        this.open = true;
        this.title = "添加客户优惠等级设置";
      },
      /** 修改按钮操作 */
      handleUpdate(row) {
        this.reset();
        const id = row.id || this.ids
        getPlan(id).then(response => {
          this.form = response.data;
          this.open = true;
          this.title = "修改客户优惠等级设置";
        });
      },
      /** 新增按钮操作 */
      handleAddDT() {
        this.reset();
        this.opendt = true;
        this.title = "添加客户优惠等级设置";
      },
      /** 修改按钮操作 */
      handleUpdateDT(row) {
        this.reset();
        const id = row.id || this.ids
        getPlan(id).then(response => {
          this.dtform = response.data;
          this.opendt = true;
          this.title = "修改客户优惠等级设置";
        });
      },
      /** 提交按钮 */
      submitForm() {
        this.form.gradeType="1";
        this.$refs["form"].validate(valid => {
          if (valid) {
            if (this.form.id != null) {
              updatePlan(this.form).then(response => {
                this.msgSuccess("修改成功");
                this.open = false;
                this.getList();
              });
            } else {
              addPlan(this.form).then(response => {
                this.msgSuccess("新增成功");
                this.open = false;
                this.getList();
              });
            }
          }
        });
      },
      /** 提交按钮 */
      submitFormDT() {
        this.dtform.gradeType="3";
        this.$refs["dtform"].validate(valid => {
          if (valid) {
            if (this.dtform.id != null) {
              updatePlan(this.dtform).then(response => {
                this.msgSuccess("修改成功");
                this.opendt = false;
                this.getList2();
              });
            } else {
              addPlan(this.dtform).then(response => {
                this.msgSuccess("新增成功");
                this.opendt= false;
                this.getList2();
              });
            }
          }
        });
      },
      /** 删除按钮操作 */
      handleDelete(row) {
        const ids = row.id || this.ids;
        this.$confirm('是否确认删除客户优惠等级设置编号为"' + ids + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delPlan(ids);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        })
      },
      /** 删除按钮操作 */
      handleDeleteDT(row) {
        const ids = row.id || this.ids;
        this.$confirm('是否确认删除客户优惠等级设置编号为"' + ids + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delPlan(ids);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        })
      },
      /** 导出按钮操作 */
      handleExport() {
        const queryParams = this.queryParams;
        this.$confirm('是否确认导出所有客户优惠等级设置数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return exportPlan(queryParams);
        }).then(response => {
          this.download(response.msg);
        })
      }
    }
  };
</script>
